# Sum of squares (PNLI)

# DATI
param n;				# Numero di punti
set N := 1..n;		# Insieme indicizzato dei punti
param d;				# Numero di dimensioni
set D := 1..d;		# Insieme indicizzato delle dimensioni
param p;				# Numero di sottoinsiemi
set P := 1..p;		# Insieme indicizzato dei sottoinsiemi
param x {N,D};		# Coordinate dei punti

# VARIABILI
var X {P,D};			# Coordinate dei centroidi
var w {N,P} binary;	# Variabili di assegnamento

# VINCOLI
# Assegnamento dei punti ai sottoinsiemi
subject to Assign {i in N}:
  sum {j in P} w[i,j] = 1;

# OBIETTIVO
# Minimizzare la somma dei quadrati delle distanze 
# tra ogni punto e il centroide del suo sottoinsieme
minimize z: sum {i in N, j in P} w[i,j] * sum {k in D} (x[i,k] - X[j,k])^2;

########################
data;

param n := 16;
param d :=  4;
param p :=  3;

param x : 1         2         3         4 :=
  1      25        61       110       -57
  2      32       -63        90        50
  3      28        25       -14       -34
  4     -41       -30        56       -29
  5      70       -81       -58        30
  6     -97        17       -71       -68
  7     103        12       -90        67
  8      12       -31       135        65
  9     -28       -26        85        21
 10      33       -78        84       -92
 11     -51        44       -23       -94
 12      40       -79       -27        63
 13     -99        80        39       -70
 14      96       -11       -33        38
 15       5         6       -12       -91
 16     -40        48       140       100;
 
 end;
 